+++
title = "Mixxeo"
weight = 1
template = "page.html"

[extra]
logo = "images/mixxeo_logo.png"
logo_size = 125
logo_only = true
+++


{% layout_centered_content() %}

The Mixxeo was the first open source digital video mixer.

<a href="/images/mixxeo_render_large.png">
  <img src="/images/mixxeo_render.jpg">
</a>

<em>[picture is a rendering - actual product appearance may vary]</em>

{% end %}



{% layout_centered_content(force_left=true, min_width=true) %}

Built on the <a href="/gateware/migen/">MiSoC and Migen</a> technologies that originated from the development experience of the Milkymist One and unlike other mixers, the Mixxeo itself does everything and processes every pixel with our own <a href="http://github.com/m-labs" target="_blank" rel="noopener noreferrer">open source hardware and software</a>. This gives us exceptional control and customization possibilities.

The Mixxeo supported mixing from two DVI or HDMI sources up to 720p60, with crossfade, fade to black and potentially other effects with a latency of less than two frames.

<b>Status (Aug 2014)</b> - Main board and gateware have been <a href="/images/mixxeo_result.jpg">mostly functional</a> for a while, mechanical design and manufacturing for the case/mechatronics are progressing slowly. If you have the skills and would like to help out, email sb at m-labs.hk or the mailing list.

<center><img src="/images/mixxeo_menu.png"><br /><br /><img src="/images/mixxeo_board.jpg" class="picimg"></center>

{% end %}
